Differences between revisions 12 and 85 (spanning 73 versions)
Revision 12 as of 2009-12-09 02:04:10
Size: 5616
Editor: ozgw
Comment:
Revision 85 as of 2014-03-03 11:40:36
Size: 5776
Editor: geirha
Comment: Changing echos to printfs, and adding a usage function to the getopts example.
Deletions are marked like this. Additions are marked like this.
Line 1: Line 1:
#pragma section-numbers 3
Line 3: Line 4:
Well, that depends a great deal on what you want to do with them. Here's a general template that might help for the simple cases: Well, that depends a great deal on what you want to do with them. There are several approaches, each with its strengths and weaknesses.

<<TableOfContents>>

=== Manual loop ===
This approach handles any arbitrary set of options, because you're writing the parser yourself. For 90% of programs, this is the simplest approach (because you rarely need fancy stuff).

This example will handle a combination of short and long options. Notice how both "--file" and "--file=FILE" are handled.

{{{#!highlight bash
#!/bin/sh
# (POSIX shell syntax)

# Reset all variables that might be set
file=""
verbose=0

while :
do
    case $1 in
        -h | --help | -\?)
            # Call your Help() or usage() function here.
            exit 0 # This is not an error, User asked help. Don't do "exit 1"
            ;;
        -f | --file)
            file=$2 # You might want to check if you really got FILE
            shift 2
            ;;
        --file=*)
            file=${1#*=} # Delete everything up till "="
            shift
            ;;
        -v | --verbose)
            # Each instance of -v adds 1 to verbosity
            verbose=$((verbose+1))
            shift
            ;;
        --) # End of all options
            shift
            break
            ;;
        -*)
            printf >&2 'WARN: Unknown option (ignored): %s\n' "$1"
            shift
            ;;
        *) # no more options. Stop while loop
            break
            ;;
    esac
done

# Suppose some options are required. Check that we got them.

if [ ! "$file" ]; then
    printf >&2 "ERROR: option '--file FILE' not given. See --help\n"
    exit 1
fi

# Rest of the program here.
# If there are input files (for example) that follow the options, they
# will remain in the "$@" positional parameters.
}}}
This parser does not handle separate options concatenated together (like `-xvf` being understood as `-x -v -f`). This could be added with effort, but this is left as an exercise for the reader.

Some Bash programmers like to write this at the beginning of their scripts to guard against unused variables:
Line 6: Line 71:
# Bash
while [[ $1 == -* ]]; do
    case "$1" in
      -h|--help|-\?) show_help; exit 0;;
      -v|--verbose) verbose=1; shift;;
      -f) if (($# > 1)); then
            output_file=$2; shift 2
          else
            printf "%s\n" "-f requires an argument"
    set -u # or, set -o nounset
}}}
The use of this breaks the loop above, as "$1" may not be set upon entering the loop. There are four solutions to this issue:

 1. Stop using `-u`.
 1. Replace `case $1 in` with `case ${1+$1} in` (as well as bandaging all the other code that `set -u` breaks).
 1. Replace `case $1 in` with `case ${1-} in` (every potentially undeclared variable could be written as ${variable-} to prevent `set -u` tripping).
 1. Stop using `-u`.

=== getopts ===
Unless it's the version from util-linux, and you use its advanced mode, '''never use getopt(1).''' Traditional versions of `getopt` cannot handle empty argument strings, or arguments with embedded whitespace.

The POSIX shell (and others) offer `getopts` which is safe to use instead. Here is a simplistic `getopts` example:

{{{#!highlight bash
#!/bin/sh

# Usage info
show_help() {
cat << EOF
Usage: ${0##*/} [-hv] [-f OUTFILE] [FILE]...
Do stuff with FILE and write the result to standard output. With no FILE
or when FILE is -, read standard input.
    
    -h display this help and exit
    -f OUTFILE write the result to OUTFILE instead of standard output.
    -v verbose mode. Can be used multiple times for increased
                verbosity.
EOF
}

# Initialize our own variables:
output_file=""
verbose=0

OPTIND=1 # Reset is necessary if getopts was used previously in the script. It is a good idea to make this local in a function.
while getopts "hvf:" opt; do
    case "$opt" in
        h)
            show_help
            exit 0
            ;;
        v) verbose=1
            ;;
        f) output_file=$OPTARG
            ;;
        '?')
            show_help >&2
Line 16: Line 120:
          fi ;;
      --) shift; break;;
      -*) echo "invalid option: $1"; show_help; exit 1;;
            ;;
Line 21: Line 123:
shift "$((OPTIND-1))" # Shift off the options and optional --.

printf 'verbose=<%s>\noutput_file=<%s>\nLeftovers:\n' "$verbose" "$output_file"
printf '<%s>\n' "$@"

# End of file
Line 22: Line 130:
Now all of the remaining arguments are the filenames which followed the optional switches. You can process those with `for i` or `"$@"`. The advantages of `getopts` are:
Line 24: Line 132:
A POSIX version of that same code:
{{{
# POSIX
while true; do
    case "$1" in
      -h|--help|-\?) show_help; exit 0;;
      -v|--verbose) verbose=1; shift;;
      -f) if [ $# -gt 1 ]; then
            output_file=$2; shift 2
          else
            printf "%s\n" "-f requires an argument"
            exit 1
          fi ;;
      --) shift; break;;
      -*) echo "invalid option: $1"; show_help; exit 1;;
      *) break;;
    esac
done
}}}
 1. It's portable, and will work in any POSIX shell e.g. dash.
 1. It can handle things like `-vf filename` in the expected Unix way, automatically.
 1. It understands `--` as the option terminator and more generally makes sure, options are parsed like for any standard command.
 1. With some implementations, the error messages will be localised in the language of the user.
Line 44: Line 137:
For more complex/generalized cases, or if you want things like "-xvf" to be handled as three separate flags, or if you want to handle [[http://www.gnu.org/software/libtool/manual/libc/Argument-Syntax.html|GNU-style long options]], you need a different approach. The disadvantage of `getopts` is that (except for ksh93 `getopts`) it can only handle short options (`-h`, not `--help`) without trickery and cannot handle options with optional arguments à la GNU.
Line 46: Line 139:
'''Never use getopt(1).''' `getopt` cannot handle empty arguments strings, or arguments with embedded whitespace. Please forget that it ever existed. There is a [[http://wiki.bash-hackers.org/howto/getopts_tutorial|getopts tutorial]] which explains what all of the syntax and variables mean. In bash, there is also `help getopts`, which might be informative.
Line 48: Line 141:
The POSIX shell (and others) offer `getopts` which is safe to use. Here is a simplistic `getopts` example: There is also still the disadvantage that options are coded in at least 2, probably 3 places - in the call to `getopts`, in the case statement that processes them and presumably in the help message that you are going to get around to writing one of these days. This is a classic opportunity for errors to creep in as the code is written and maintained - often not discovered till much, much later. This can be avoided by using callback functions, but this approach kind of defeats the purpose of using getopts at all.
Line 50: Line 143:
{{{
# POSIX
x=1 # Avoids an error if we get no options at all.
while getopts "abcf:g:h:" opt; do
  case "$opt" in
    a) echo "You said a";;
    b) echo "You said b";;
    c) echo "You said c";;
    f) echo "You said f, with argument $OPTARG";;
    g) echo "You said g, with argument $OPTARG";;
    h) echo "You said h, with argument $OPTARG";;
  esac
  x=$OPTIND
done
shift $(($x-1))
echo "Left overs: $@"
}}}
Line 68: Line 144:
There is still the disadvantage that options are coded in at least 2, probably 3 places - in the call to `getopts`, in the case statement that processes them and presumably in the help message that you are going to get around to writing one of these days. This is a classic opportunity for errors to creep in as the code is written and maintained - often not discovered till much, much later. For other, more complicated ways of option parsing, see ComplexOptionParsing.
Line 70: Line 146:
Another approach is to check options with `if` statements "on demand". A function like this one may be useful:

{{{
# Bash
HaveOpt() {
  local needle=$1
  shift
  while [[ $1 == -* ]]; do
    case "$1" in
      --) return 1; # by convention, -- is end of options
      $needle) return 0;;
    esac
    shift
  done
  return 1
}
if HaveOpt --quick "$@"; then echo "Option quick is set"; fi
}}}
and it will work if script is run as:

 * YES: ./script --quick
 * YES: ./script -other --quick
but will stop on first argument with no "-" in front (or on --):

 * NO: ./script -bar foo --quick
 * NO: ./script -bar -- --quick
Of course, this approach (iterating over the argument list every time you want to check for one) is far less efficient than just iterating once and setting flag variables. But it does offer a consolidation of the option-handling code into a single place (or two places if you count the help message).

[[http://bhepple.freeshell.org/oddmuse/wiki.cgi/process-getopt|bhepple]] suggests the use of [[http://sourceforge.net/projects/process-getopt/|process-getopt]] (GPL licensed) and offers this example code:

{{{
PROG=$(basename $0)
VERSION='1.2'
USAGE="A tiny example using process-getopt(1)"

# call process-getopt functions to define some options:
source /usr/bin/process-getopt

SLOT=""
SLOT_func() { [ "${1:-""}" ] && SLOT="yes"; } # callback for SLOT option
add_opt SLOT "boolean option" s "" slot

TOKEN=""
TOKEN_func() { [ "${1:-""}" ] && TOKEN="$2"; } # callback for TOKEN option
add_opt TOKEN "this option takes a value" t n token number

add_std_opts # define the standard options --help etc:

TEMP=$(call_getopt "$@") || exit 1
eval set -- "$TEMP" # just as with getopt(1)

# remove the options from the command line
process_opts "$@" || shift "$?"

echo "SLOT=$SLOT"
echo "TOKEN=$TOKEN"
echo "args=$@"
}}}
Here, all information about each option is defined in one place making for much easier authoring and maintenance. A lot of the dirty work is handled automatically and standards are obeyed as in getopt(1) - because it calls getopt for you.
 . ''Actually, what the author forgot to say was that it's actually using `getopts` semantics, rather than `getopt`. I ran this test:''
 {{{
 wooledg@wooledg:~/process-getopt-1.6$ set -- one 'rm -rf /' 'foo;bar' "'"
 wooledg@wooledg:~/process-getopt-1.6$ call_getopt "$@"
  -- 'rm -rf /' 'foo;bar' ''\'''
 }}}
 . ''It appears to be intelligent enough to handle null options, whitespace-containing options, and single-quote-containing options in a manner that makes the [[BashFAQ/048|eval]] not blow up in your face. But this is not an endorsement of the process-getopt software overall; I don't know it well enough. -GreyCat

 . ''It's written and tested on Linux where the getopt(1) is very like `getopts`. In the interests of portability I'll see if `getopts` can be used and update this note when I have some results.''
----
'' CategoryShell ''

How can I handle command-line arguments (options) to my script easily?

Well, that depends a great deal on what you want to do with them. There are several approaches, each with its strengths and weaknesses.

Manual loop

This approach handles any arbitrary set of options, because you're writing the parser yourself. For 90% of programs, this is the simplest approach (because you rarely need fancy stuff).

This example will handle a combination of short and long options. Notice how both "--file" and "--file=FILE" are handled.

   1 #!/bin/sh
   2 # (POSIX shell syntax)
   3 
   4 # Reset all variables that might be set
   5 file=""
   6 verbose=0
   7 
   8 while :
   9 do
  10     case $1 in
  11         -h | --help | -\?)
  12             #  Call your Help() or usage() function here.
  13             exit 0      # This is not an error, User asked help. Don't do "exit 1"
  14             ;;
  15         -f | --file)
  16             file=$2     # You might want to check if you really got FILE
  17             shift 2
  18             ;;
  19         --file=*)
  20             file=${1#*=}        # Delete everything up till "="
  21             shift
  22             ;;
  23         -v | --verbose)
  24             # Each instance of -v adds 1 to verbosity
  25             verbose=$((verbose+1))
  26             shift
  27             ;;
  28         --) # End of all options
  29             shift
  30             break
  31             ;;
  32         -*)
  33             printf >&2 'WARN: Unknown option (ignored): %s\n' "$1"
  34             shift
  35             ;;
  36         *)  # no more options. Stop while loop
  37             break
  38             ;;
  39     esac
  40 done
  41 
  42 # Suppose some options are required. Check that we got them.
  43 
  44 if [ ! "$file" ]; then
  45     printf >&2 "ERROR: option '--file FILE' not given. See --help\n"
  46     exit 1
  47 fi
  48 
  49 # Rest of the program here.
  50 # If there are input files (for example) that follow the options, they
  51 # will remain in the "$@" positional parameters.

This parser does not handle separate options concatenated together (like -xvf being understood as -x -v -f). This could be added with effort, but this is left as an exercise for the reader.

Some Bash programmers like to write this at the beginning of their scripts to guard against unused variables:

    set -u     # or, set -o nounset

The use of this breaks the loop above, as "$1" may not be set upon entering the loop. There are four solutions to this issue:

  1. Stop using -u.

  2. Replace case $1 in with case ${1+$1} in (as well as bandaging all the other code that set -u breaks).

  3. Replace case $1 in with case ${1-} in (every potentially undeclared variable could be written as ${variable-} to prevent set -u tripping).

  4. Stop using -u.

getopts

Unless it's the version from util-linux, and you use its advanced mode, never use getopt(1). Traditional versions of getopt cannot handle empty argument strings, or arguments with embedded whitespace.

The POSIX shell (and others) offer getopts which is safe to use instead. Here is a simplistic getopts example:

   1 #!/bin/sh
   2 
   3 # Usage info
   4 show_help() {
   5 cat << EOF
   6 Usage: ${0##*/} [-hv] [-f OUTFILE] [FILE]...
   7 Do stuff with FILE and write the result to standard output. With no FILE
   8 or when FILE is -, read standard input.
   9     
  10     -h          display this help and exit
  11     -f OUTFILE  write the result to OUTFILE instead of standard output.
  12     -v          verbose mode. Can be used multiple times for increased
  13                 verbosity.
  14 EOF
  15 }                
  16 
  17 # Initialize our own variables:
  18 output_file=""
  19 verbose=0
  20 
  21 OPTIND=1 # Reset is necessary if getopts was used previously in the script.  It is a good idea to make this local in a function.
  22 while getopts "hvf:" opt; do
  23     case "$opt" in
  24         h)
  25             show_help
  26             exit 0
  27             ;;
  28         v)  verbose=1
  29             ;;
  30         f)  output_file=$OPTARG
  31             ;;
  32         '?')
  33             show_help >&2
  34             exit 1
  35             ;;
  36     esac
  37 done
  38 shift "$((OPTIND-1))" # Shift off the options and optional --.
  39 
  40 printf 'verbose=<%s>\noutput_file=<%s>\nLeftovers:\n' "$verbose" "$output_file"
  41 printf '<%s>\n' "$@"
  42 
  43 # End of file

The advantages of getopts are:

  1. It's portable, and will work in any POSIX shell e.g. dash.
  2. It can handle things like -vf filename in the expected Unix way, automatically.

  3. It understands -- as the option terminator and more generally makes sure, options are parsed like for any standard command.

  4. With some implementations, the error messages will be localised in the language of the user.

The disadvantage of getopts is that (except for ksh93 getopts) it can only handle short options (-h, not --help) without trickery and cannot handle options with optional arguments à la GNU.

There is a getopts tutorial which explains what all of the syntax and variables mean. In bash, there is also help getopts, which might be informative.

There is also still the disadvantage that options are coded in at least 2, probably 3 places - in the call to getopts, in the case statement that processes them and presumably in the help message that you are going to get around to writing one of these days. This is a classic opportunity for errors to creep in as the code is written and maintained - often not discovered till much, much later. This can be avoided by using callback functions, but this approach kind of defeats the purpose of using getopts at all.

For other, more complicated ways of option parsing, see ComplexOptionParsing.


CategoryShell

BashFAQ/035 (last edited 2024-02-26 07:51:38 by larryv)